Chuyển đến nội dung
Diễn đàn CADViet
  • Thông báo

    • Nguyen Hoanh

      CADViet đã hoàn tất nâng cấp   14/09/2017

      Chào các bạn, CADViet đã hoàn tất việc nâng cấp lên phiên bản mới. Tất cả các chức năng đã hoạt động theo kỳ vọng của ban quản trị. Nếu có vấn đề gì cần phản hồi, các bản post ở đây nhé: Trân trọng, Nguyễn Hoành.
Đăng nhập để thực hiện theo  
phamhung12

Lisp cửa đi

Các bài được khuyến nghị

phamhung12    1

Mình có tìm được 1 lisp vẽ cửa đi D1 = 1 cánh, D2 = 2 cánh

Cách dùng : 1/ Chọn điểm 1 là điểm góc của tường, Pick diem 2 là bắt đầu vẽ cửa

2/ Pick diem 3 là diểm vuông góc với cạnh 1&2 nằm trên cạnh tường // cạnh 1&2 cũng là hướng cửa

3/ Bề rộng cửa --> Vẽ

Nhờ bác Tot77 hoặc các bác nào giỏi Lisp phát triển thêm loại cửa D4 = 4 cánh giúp mình với. Thanks!

;;Chuong trinh ve cua di
;(alert "checkpoint0")
(setq oldosmode (getvar "osmode")
ORTHO (getvar "ORTHOMODE"))
(defun D1 () 
       (command ".line" p2 (polar p3 ang2 r) "" ".line" p4 p5 "")
       (if (or (and (> (car p2) (car p1)) 
                    (> (cadr p2) (cadr p3))
               ) 
               (and (< (car p2) (car p1)) 
                    (< (cadr p2) (cadr p3))
               ) 
               (and (> (cadr p1) (cadr p2)) 
                    (> (car p2) (car p3))
               )
               (and (< (cadr p1) (cadr p2)) 
                    (< (car p2) (car p3))
               )
           )
           (setq ang 90)
           (setq ang -90)
       ) ; end of if

       (command ".arc"  "C" p3 (polar p3 ang2 r) "A" ang "")
      
); END OF D1
;(alert "checkpoint1")
(defun D2 ()
       (command ".line" p2 (polar p3 ang2 (/ r 2)) ""
                ".line" p5 (polar p4 ang2 (/ r 2)) ""
       )
        (if (or (and (> (car p2) (car p1)) 
                    (> (cadr p2) (cadr p3))
               ) 
               (and (< (car p2) (car p1)) 
                    (< (cadr p2) (cadr p3))
               ) 
               (and (> (cadr p1) (cadr p2)) 
                    (> (car p2) (car p3))
               )
               (and (< (cadr p1) (cadr p2)) 
                    (< (car p2) (car p3))
               )
           )
           (setq ang 90)
           (setq ang -90)
       ) ; end of if
       (command ".arc"  "C" p3 (polar p3 ang2 (/ r 2)) "A" ang "")
       (setq m (ssget "L"))
       (command ".mirror" m "" (polar p2 ang1 (/ r 2)) (polar p3 ang1 (/ r 2)) "")
) ;End of D2

; Than chuong trinh chinh
(defun c:cua (/ p1 p2 p3 p4 p5 p23 p45 r res i ang)
(command "undo" "be")
       (initget "D1 D2")
       (setq res (getkword "\D1 1CANH _ D2 2CANH [D1/D2]? <D1>:"))

; Nhap so lieu 
       (setvar "osmode" 33)
       (setq p1 ( getpoint "\nDIEM THU 1, GOC TUONG:"))
       (setvar "osmode" 512 )
       (setvar "ORTHOMODE" 1)
       (setq p2 ( getpoint p1 "\nDIEM THU 2:"))    
       (setvar "lastpoint" p2)
       (setvar "osmode" 128)
 ;(alert "checkpoint6")          
       (setq p3 ( getpoint p2 "DIEM THU 3:")
             ang1 (angle p1 p2)
             ang2 (angle p2 p3)
             r (getreal "\nBe rong cua:")
             p4 (polar p3 ang1 r)
             p5 (polar p2 ang1 r)
             p23 (polar p2 ang2 (/ (distance p2 p3) 2))
             p45 (polar p5 ang2 (/ (distance p5 p4) 2))
       )
       (setvar "osmode" 0)
       (command ".break" p2 p5 
                ".break" p3 p4)
       (if (= res "D1") (D1))
       (if (= res "D2") (D2))
       (setvar "osmode" oldosmode)
(SETVAR "ORTHOMODE" ORTHO) 
(command "undo" "e")
   (princ)     
); end of programmer

 

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
phamhung12    1

Có bác lisper pro nào giúp mình với... Mỗi lần vẽ cửa 4 cánh là phải Miror 2 lần từ cửa 2 cánh + Trim phần thừa của tường nữa :( , hơi bị lâu

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
Tot77    501

Bạn thử cái này.

 

 
(setq oldosmode (getvar "osmode")
      ORTHO (getvar "ORTHOMODE"))
(defun D1 () 
       (command ".line" p2 (polar p3 ang2 r) "")
       (command ".line" p4 p5 "")
       (if (or (and (> (car p2) (car p1)) 
                    (> (cadr p2) (cadr p3))
               ) 
               (and (< (car p2) (car p1)) 
                    (< (cadr p2) (cadr p3))
               ) 
               (and (> (cadr p1) (cadr p2)) 
                    (> (car p2) (car p3))
               )
               (and (< (cadr p1) (cadr p2)) 
                    (< (car p2) (car p3))
               )
           )
           (setq ang 90)
           (setq ang -90)
       ) ; end of if
 
       (command ".arc"  "C" p3 (polar p3 ang2 r) "A" ang "")
      
); END OF D1
;(alert "checkpoint1")
(defun D2 ()
       (command ".line" p2 (polar p3 ang2 (/ r 2)) ""
                ".line" p5 (polar p4 ang2 (/ r 2)) ""
       )
        (if (or (and (> (car p2) (car p1)) 
                    (> (cadr p2) (cadr p3))
               ) 
               (and (< (car p2) (car p1)) 
                    (< (cadr p2) (cadr p3))
               ) 
               (and (> (cadr p1) (cadr p2)) 
                    (> (car p2) (car p3))
               )
               (and (< (cadr p1) (cadr p2)) 
                    (< (car p2) (car p3))
               )
           )
           (setq ang 90)
           (setq ang -90)
       ) ; end of if
       (command ".arc"  "C" p3 (polar p3 ang2 (/ r 2)) "A" ang "")
       (setq m (ssget "L"))
       (command ".mirror" m "" (polar p2 ang1 (/ r 2)) (polar p3 ang1 (/ r 2)) "")
) ;End of D2
 
(defun D4 ()
       (setq ss0 (ssadd))
       (command ".line" p2 (polar p3 ang2 (/ r 4)) "")
       (ssadd (entlast) ss0)
        (if (or (and (> (car p2) (car p1)) 
                    (> (cadr p2) (cadr p3))
               ) 
               (and (< (car p2) (car p1)) 
                    (< (cadr p2) (cadr p3))
               ) 
               (and (> (cadr p1) (cadr p2)) 
                    (> (car p2) (car p3))
               )
               (and (< (cadr p1) (cadr p2)) 
                    (< (car p2) (car p3))
               )
           )
           (setq ang 90)
           (setq ang -90)
       ) ; end of if
       (command ".arc"  "C" p3 (polar p3 ang2 (/ r 4)) "A" ang "")
       (ssadd (entlast) ss0)
       (command ".line" (setq tm (polar p3 ang1 (/ r 4))) (polar tm ang2 (/ r 4)) "")
       (ssadd (entlast) ss0)
       (command ".arc"  "C" tm (polar tm ang2 (/ r 4)) "A" ang "")
       (ssadd (entlast) ss0)      
  
       (command ".mirror" ss0 "" (polar p2 ang1 (/ r 2)) (polar p3 ang1 (/ r 2)) "")
)
 
; Than chuong trinh chinh
(defun c:cua (/ )
(command "undo" "be")
       (initget "D1 D2 D4")
       (setq res (getkword "\D1 1CANH _ D2 2CANH _ D4 4CANH [D1/D2/D4]? <D1>:"))
       (if (not res) (setq res "D1"))
; Nhap so lieu 
       (setvar "osmode" 33)
       (setq p1 ( getpoint "\nDIEM THU 1, GOC TUONG:"))
       (setvar "osmode" 512 )
       (setvar "ORTHOMODE" 1)
       (setq p2 ( getpoint p1 "\nDIEM THU 2:"))    
       (setvar "lastpoint" p2)
       (setvar "osmode" 128)
 ;(alert "checkpoint6")          
       (setq p3 ( getpoint p2 "DIEM THU 3:")
             ang1 (angle p1 p2)
             ang2 (angle p2 p3)
             r (getreal "\nBe rong cua:")
             p4 (polar p3 ang1 r)
             p5 (polar p2 ang1 r)
             p23 (polar p2 ang2 (/ (distance p2 p3) 2))
             p45 (polar p5 ang2 (/ (distance p5 p4) 2))
       )
       (setvar "osmode" 0)
       (command ".break" p2 p5 
                ".break" p3 p4)
       (if (= res "D1") (D1))
       (if (= res "D2") (D2))
       (if (= res "D4") (D4))
       (setvar "osmode" oldosmode)
(SETVAR "ORTHOMODE" ORTHO) 
(command "undo" "e")
   (princ)     
); end of programmer
 

 

 

Có lisper chắc phải có csharper và vbaper chứ hả?  :)  :)

  • Vote tăng 1

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
Oohlala    2

Bạn thử cái này.

 
(setq oldosmode (getvar "osmode")
      ORTHO (getvar "ORTHOMODE"))
(defun D1 () 
       (command ".line" p2 (polar p3 ang2 r) "")
       (command ".line" p4 p5 "")
       (if (or (and (> (car p2) (car p1)) 
                    (> (cadr p2) (cadr p3))
               ) 
               (and (< (car p2) (car p1)) 
                    (< (cadr p2) (cadr p3))
               ) 
               (and (> (cadr p1) (cadr p2)) 
                    (> (car p2) (car p3))
               )
               (and (< (cadr p1) (cadr p2)) 
                    (< (car p2) (car p3))
               )
           )
           (setq ang 90)
           (setq ang -90)
       ) ; end of if
 
       (command ".arc"  "C" p3 (polar p3 ang2 r) "A" ang "")
      
); END OF D1
;(alert "checkpoint1")
(defun D2 ()
       (command ".line" p2 (polar p3 ang2 (/ r 2)) ""
                ".line" p5 (polar p4 ang2 (/ r 2)) ""
       )
        (if (or (and (> (car p2) (car p1)) 
                    (> (cadr p2) (cadr p3))
               ) 
               (and (< (car p2) (car p1)) 
                    (< (cadr p2) (cadr p3))
               ) 
               (and (> (cadr p1) (cadr p2)) 
                    (> (car p2) (car p3))
               )
               (and (< (cadr p1) (cadr p2)) 
                    (< (car p2) (car p3))
               )
           )
           (setq ang 90)
           (setq ang -90)
       ) ; end of if
       (command ".arc"  "C" p3 (polar p3 ang2 (/ r 2)) "A" ang "")
       (setq m (ssget "L"))
       (command ".mirror" m "" (polar p2 ang1 (/ r 2)) (polar p3 ang1 (/ r 2)) "")
) ;End of D2
 
(defun D4 ()
       (setq ss0 (ssadd))
       (command ".line" p2 (polar p3 ang2 (/ r 4)) "")
       (ssadd (entlast) ss0)
        (if (or (and (> (car p2) (car p1)) 
                    (> (cadr p2) (cadr p3))
               ) 
               (and (< (car p2) (car p1)) 
                    (< (cadr p2) (cadr p3))
               ) 
               (and (> (cadr p1) (cadr p2)) 
                    (> (car p2) (car p3))
               )
               (and (< (cadr p1) (cadr p2)) 
                    (< (car p2) (car p3))
               )
           )
           (setq ang 90)
           (setq ang -90)
       ) ; end of if
       (command ".arc"  "C" p3 (polar p3 ang2 (/ r 4)) "A" ang "")
       (ssadd (entlast) ss0)
       (command ".line" (setq tm (polar p3 ang1 (/ r 4))) (polar tm ang2 (/ r 4)) "")
       (ssadd (entlast) ss0)
       (command ".arc"  "C" tm (polar tm ang2 (/ r 4)) "A" ang "")
       (ssadd (entlast) ss0)      
  
       (command ".mirror" ss0 "" (polar p2 ang1 (/ r 2)) (polar p3 ang1 (/ r 2)) "")
)
 
; Than chuong trinh chinh
(defun c:cua (/ )
(command "undo" "be")
       (initget "D1 D2 D4")
       (setq res (getkword "\D1 1CANH _ D2 2CANH _ D4 4CANH [D1/D2/D4]? <D1>:"))
       (if (not res) (setq res "D1"))
; Nhap so lieu 
       (setvar "osmode" 33)
       (setq p1 ( getpoint "\nDIEM THU 1, GOC TUONG:"))
       (setvar "osmode" 512 )
       (setvar "ORTHOMODE" 1)
       (setq p2 ( getpoint p1 "\nDIEM THU 2:"))    
       (setvar "lastpoint" p2)
       (setvar "osmode" 128)
 ;(alert "checkpoint6")          
       (setq p3 ( getpoint p2 "DIEM THU 3:")
             ang1 (angle p1 p2)
             ang2 (angle p2 p3)
             r (getreal "\nBe rong cua:")
             p4 (polar p3 ang1 r)
             p5 (polar p2 ang1 r)
             p23 (polar p2 ang2 (/ (distance p2 p3) 2))
             p45 (polar p5 ang2 (/ (distance p5 p4) 2))
       )
       (setvar "osmode" 0)
       (command ".break" p2 p5 
                ".break" p3 p4)
       (if (= res "D1") (D1))
       (if (= res "D2") (D2))
       (if (= res "D4") (D4))
       (setvar "osmode" oldosmode)
(SETVAR "ORTHOMODE" ORTHO) 
(command "undo" "e")
   (princ)     
); end of programmer
 

Có lisper chắc phải có csharper và vbaper chứ hả?  :)  :)

bạn ơi sao mình dùng lsp này khi nhập lệnh D1, D2 thì toàn báo là unknown command 

  • Vote giảm 1

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác

Tạo một tài khoản hoặc đăng nhập để nhận xét

Bạn cần phải là một thành viên để lại một bình luận

Tạo tài khoản

Đăng ký một tài khoản mới trong cộng đồng của chúng tôi. Điều đó dễ mà.

Đăng ký tài khoản mới

Đăng nhập

Bạn có sẵn sàng để tạo một tài khoản ? Đăng nhập tại đây.

Đăng nhập ngay

Đăng nhập để thực hiện theo  

×